package com.example.module.admin.req;

import com.example.frame.base.BaseUpdateRequest;
import javax.validation.constraints.NotNull;
import org.hibernate.validator.constraints.Length;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.Pattern;

/**
 * MappingUpdateRequest - 映射更新
 *
 * @author author
 * @version 0.0.1
 * @since 2019-09-28
 */
public class  MappingUpdateRequest extends BaseUpdateRequest {

    /**
     * 主键
     */
    @NotNull(message = "主键不能为NULL")
    private Long id;

    @NotNull(message = "服务Id不能为空")
    private Long serviceId;

    /**
     * NAME - 映射名称
     */
    @NotNull(message = "映射名称不能为空")
    private String name;

    /**
     * VALUE - 映射值
     */
    @NotNull(message = "映射值不能为空")
    @Pattern(regexp = "[^/]*", message = "映射值不能存在/")
    @Pattern(regexp = "\\w*", message = "映射值需为英文")
    private String value;

    /**
     * BZ - 备注
     */
    private String bz;

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public String getBz() {
        return bz;
    }

    public void setBz(String bz) {
        this.bz = bz;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getServiceId() {
        return serviceId;
    }

    public void setServiceId(Long serviceId) {
        this.serviceId = serviceId;
    }
}
