<div id="app" v-cloak>
    <el-card class="box-card control">

        <el-row>
            <el-col :span="3">
                <a>Nginx 控制中心</a>
            </el-col>
            <el-col :span="2">
                <a @click="nginxStart">
                    <el-image v-if="run" :src="'${Uri.getUrl('/static/img/start_.png')}'"
                              style="width: 50px; height: 50px"
                              fit="fill"></el-image>
                    <el-image v-if="!run" :src="'${Uri.getUrl('/static/img/start.png')}'"
                              style="width: 50px; height: 50px"
                              fit="fill"></el-image>
                </a>
            </el-col>
            <el-col :span="2">
                <a @click="nginxStop">
                    <el-image v-if="run" :src="'${Uri.getUrl('/static/img/stop.png')}'"
                              style="width: 50px; height: 50px"
                              fit="fill"></el-image>
                    <el-image v-if="!run" :src="'${Uri.getUrl('/static/img/stop_.png')}'"
                              style="width: 50px; height: 50px"
                              fit="fill"></el-image>
                </a>
            </el-col>
            <el-col :span="2">
                <a @click="nginxReload">
                    <el-image v-if="run" :src="'${Uri.getUrl('/static/img/reload.png')}'"
                              style="width: 50px; height: 50px"
                              fit="fill"></el-image>
                    <el-image v-if="!run" :src="'${Uri.getUrl('/static/img/reload_.png')}'"
                              style="width: 50px; height: 50px"
                              fit="fill"></el-image>
                </a>
            </el-col>
        </el-row>
    </el-card>

    <el-card class="box-card" v-for="item in services" :key="item.id">
        <el-row>
            <el-col :span="5">
                <el-input size="small" v-model="item.value" placeholder="请输入端口" style="width: 160px;text-align: center"
                          suffix-icon="el-icon-edit">
                    <template slot="prepend">端口</template>
                </el-input>
            </el-col>
            <el-col :span="6">
                <el-input size="small" v-model="item.bz" placeholder="请输入备注" style="width: 200px;text-align: center"
                          suffix-icon="el-icon-collection-tag">
                    <template slot="prepend">备注</template>
                </el-input>
            </el-col>
            <el-col :span="2">
                <el-button type="primary" size="small" icon="el-icon-refresh">保存</el-button>
            </el-col>
            <el-col :span="11">
                <span style="float: right;">
                <el-button type="success" size="small" icon="el-icon-plus" @click="onAction(['create',item])">新增
                </el-button>
                <el-button size="small" icon="el-icon-refresh" @click="onFind"></el-button>
                </span>

                <el-dialog :title="form.title" :visible.sync="form.dialog">
                    <el-form :model="form" :rules="formRules" ref="form" label-width="90px"
                             style="width: 290px;">
                        <el-form-item label="名称" prop="name">
                            <el-input v-model="form.name" clearable size="small" placeholder="简要描述"></el-input>
                        </el-form-item>
                        <el-form-item label="路径" prop="value">
                            <el-input v-model="form.value" clearable size="small" placeholder="字母数字组合">
                                <template slot="prepend">:{{form.port}}/</template>
                            </el-input>
                        </el-form-item>
                        <el-form-item label="备注" prop="bz">
                            <el-input type="textarea" v-model="form.bz" clearable size="small"
                                      placeholder="备注信息"></el-input>
                        </el-form-item>
                    </el-form>
                    <span slot="footer" class="dialog-footer">
                        <el-button size="small" @click="form.dialog = false">取 消</el-button>
                        <el-button size="small" type="primary" @click="onAction(['save',''])">保存</el-button>
                    </span>
                </el-dialog>
            </el-col>
        </el-row>

        <el-table
                :data="item.mappingList.filter(data => !item.search || data.name.toLowerCase().includes(item.search.toLowerCase())|| data.value.toLowerCase().includes(item.search.toLowerCase()))"
                style="width: 100%">
            <el-table-column
                    width="150px"
                    label="名称"
                    prop="name">
            </el-table-column>
            <el-table-column
                    width="150px"
                    label="路径"
                    prop="value">
            </el-table-column>
            <el-table-column
                    width="150px"
                    label="创建日期"
                    prop="createTime">
            </el-table-column>
            <el-table-column
                    label="备注"
                    prop="bz">
            </el-table-column>
            <el-table-column
                    width="150px"
                    align="right">
                <template slot="header" slot-scope="scope">
                    <el-input
                            v-model="item.search"
                            size="small"
                            placeholder="输入关键字搜索"/>
                </template>
                <template slot-scope="scope">
                    <el-button
                            size="mini"
                            @click="onAction(['edit',scope.row,item])">编辑
                    </el-button>
                    <el-button
                            size="mini"
                            type="danger"
                            @click="onAction('delete', scope.row)">删除
                    </el-button>
                </template>
            </el-table-column>
        </el-table>
    </el-card>
</div>
<style>
    #app {
        padding: 10px;
        width: 900px;
    }

    .box-card {
        margin: 10px;
    }

    .control a:first-child {
        padding-right: 10px;
    }

    .control a {
        display: inline-block;
        line-height: 50px;
        height: 50px;
        vertical-align: top;
    }

    .control a:hover {
        background: #e7e7e7;
    }

    .control a:first-child:hover {
        background: #ffffff;
    }
</style>
<script>
    var app = new Vue({
        el: "#app",
        data: {
            form: {
                title: "",
                dialog: false,
                id: '',
                value: '',
                name: '',
                bz: ''
            },
            formRules: {
                roleName: [
                    {required: true, message: '不能为空', trigger: 'blur'},
                    {min: 1, max: 50, message: '长度在 1 到 50 字符', trigger: 'blur'}
                ],
                roleCode: [
                    {required: true, message: '不能为空', trigger: 'blur'},
                    {min: 1, max: 50, message: '长度在 1 到 50 个字符', trigger: 'blur'}
                ],
            },
            services: [],
            run: ${run?default('false')}
        },
        methods: {
            onFind: function () {
                ajax.portLoad().then(function (response) {
                    if (response.errors.length > 0) {
                        nav.e(response.errors[0].message);
                    } else {
                        for (var i in response.result) {
                            response.result[i].search = "";
                        }
                        this.services = response.result;
                    }
                }.bind(this))
            },
            onAction: function (arg) {
                const action = arg[0];
                switch (action) {
                    case "create":
                        this.form.title = '新增';
                        this.form.serviceId = arg[1].id;
                        this.form.port = arg[1].value;
                        this.form.id = '';
                        this.form.name = '';
                        this.form.value = '';
                        this.form.bz = '';
                        this.form.dialog = true;
                        break;
                    case "edit":
                        this.form.title = '编辑';
                        this.form.id = arg[1].id;
                        this.form.serviceId = arg[1].serviceId;
                        this.form.port = arg[2].value;
                        this.form.name = arg[1].name;
                        this.form.value = arg[1].value;
                        this.form.bz = arg[1].bz;
                        this.form.dialog = true;
                        break;
                    case "save":
                        if (this.form.id) {
                            ajax.mappingUpdate(this.form).then(function (response) {
                                if (response.errors.length > 0) {
                                    nav.e(response.errors[0].message);
                                } else {
                                    this.onFind();
                                    this.form.dialog = false;
                                }
                            }.bind(this))
                        } else {
                            ajax.mappingCreate(this.form).then(function (response) {
                                if (response.errors.length > 0) {
                                    nav.e(response.errors[0].message);
                                } else {
                                    this.onFind();
                                    this.form.dialog = false;
                                }
                            }.bind(this))
                        }
                        break;
                    case "delete":
                        this.$confirm('将删除该项, 是否继续?', '提示', {
                            confirmButtonText: '确定',
                            cancelButtonText: '取消',
                            type: 'warning'
                        }).then(function () {
                            ajax.mappingDelete({id: arg[1].id}).then(function (response) {
                                if (response.errors.length > 0) {
                                    nav.e(response.errors[0].message);
                                } else {
                                    nav.s("删除成功")
                                    this.onFind();
                                }
                            }.bind(this))
                        }.bind(this)).catch(function (action) {

                        });
                        break;
                }
            },
            startMonitor: function () {
                if (window.EventSource) {
                    window.evtSource = new EventSource('${Uri.getUrl("/sse/1")}');
                    window.evtSource.addEventListener('message', function (e) {

                        var msg = JSON.parse(e.data);
                        if (msg.type == 'NGINX_STATE') {//状态推送
                            if (this.run != msg.object.run) {

                                this.$notify.info({
                                    title: '提示',
                                    message: "Nginx 运行状态发生变化:"
                                });
                                this.run = msg.object.run;
                            }
                        }
                    }.bind(this))
                }
            },
            nginxStart: function () {
                ajax.nginxStart().then(function (response) {
                    if (response.errors.length > 0) {
                        nav.e(response.errors[0].message);
                    } else {
                        this.onFind();
                        this.form.dialog = false;
                    }
                }.bind(this))
            },
            nginxStop: function () {
                ajax.nginxStop().then(function (response) {
                    if (response.errors.length > 0) {
                        nav.e(response.errors[0].message);
                    } else {
                        this.onFind();
                        this.form.dialog = false;
                    }
                }.bind(this))
            },
            nginxReload: function () {
                ajax.nginxReload().then(function (response) {
                    if (response.errors.length > 0) {
                        nav.e(response.errors[0].message);
                    } else {
                        this.onFind();
                        this.form.dialog = false;
                    }
                }.bind(this))
            }
        },
        created: function () {
        },
        mounted: function () {
            this.onFind();
            this.startMonitor();
        },
        watch: {}
    })
</script>
